<?php
// +-----------------------------------------------------------------------+
// | Plugin Name : Event Cats                                              |
// | Plugin Version : 1.0                                                  |
// | File Version : 1.0                                                    |
// | Plugin Version author : LucMorizur                                    |
// | Plugin description : (plugin for Piwigo, http://piwigo.org )          |
// | This plugin allows an account to be automatically logged in ; and to  |
// | let users duplicate the account they are logged with, to get benefits |
// | of the groups of the previous account, immediately on their new acc.  |
// | Ce plugin permet d'identifier automatiquement un compte ; et permet à |
// | un utilisateur de dupliquer un compte, pour que le nouveau compte     |
// | bénéficie immédiatement de l'affectation aux groupes de l'ancien cpte |
// +-----------------------------------------------------------------------+

// +-----------------------------------------------------------------------+
// | Piwigo - a PHP based picture gallery                                  |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008-2009 Piwigo Team                  http://piwigo.org |
// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $template, $conf, $page,
 $ec_lists,   // array of following arrays :
              //   $ec_lists['ec_table'] :
              //     Event Cats table, in function of each entry id
              //   $ec_lists['ec_codes'] : // Used ?
              //     array of useful data, in function of entries codes
              //   $ec_lists['add_pages'] :
              //     array of Add. Pages names in function of their id
              //   $ec_lists['categories'] :
              //     array of category names in function of their id
              //   $ec_lists['user_ids'] :
              //     array of usernames in function of their id
 $ec_ap_ok;   // whether Additional Pages is installed and activated

/****************************************************************************/

$code_list = array();
build_ec_lists(); // in evntcats_funcs.inc.php

/****************************************************************
* Construction of array var to be transmitted to tpl file,      *
* containing all infos to be displayed in the code array table. *
****************************************************************/

$span_err_pre = '<span style = "color: red; font-weight: bold;">';
$span_err_end = '</span>';

foreach ($ec_lists['ec_table'] as $ec_entry) {
    
  $a = NULL;
  $dspl     = '';
  $url_end  = '';
  $i        = intval($ec_entry['id']);
  $arg1     = $ec_entry['arg1'];
  $arg1_int = intval($arg1);
  $arg2     = $ec_entry['arg2'];
  $arg2_int = intval($arg2);
  $log_OK   = is_in($ec_entry['action'], 'ec_ok');
  
  // No specific need for "code" displaying
  
  // "username" displaying
  $username = ($log_OK) ?
   $ec_lists['user_ids'][intval($ec_entry['user_id'])] : '';
  
  // No specific need for "action" displaying
  
  // "displayed page" : # of the AP, or of the category...
  switch ($ec_entry['action']) {
    
    case 'ec_ok' :
    case 'ec_ok_img_pb' :
      $a = 0;
      if (!empty($ec_entry['arg1'])) $a++;
      if (!empty($ec_entry['arg2'])) $a+= 2;
      switch ($a) {
        case 0: // Home
          $dspl = l10n('ec_dspl_ok_home');
        break;
        case 1: // Category
        case 3: // Image
          $url_end = ($ec_entry['forced'] == 'true') ? '' : '&cat='.$arg1;
          $dspl =
           l10n('ec_dspl_ok_cat_pre').
           $arg1.
           l10n('ec_dspl_ok_cat_mid').
           $ec_lists['categories'][$arg1_int].
           l10n('ec_dspl_ok_cat_end')
          ;
          if (is_in($ec_entry['action'], '_img_pb')) {
            $url_end.= ($url_end == '') ? '' : '&img='.$arg2;
            $page['errors'][] = 
             $ec_entry['code'].' : '.l10n('ec_image_miss');
            $dspl.=
             '<br>'.$span_err_pre.
             l10n('ec_dspl_nok_img2_pre').
             $arg2.
             l10n('ec_dspl_nok_img2_mid').
             $arg1.
             l10n('ec_dspl_nok_img2_end').
             $span_err_end
            ;
          }
          elseif ($a == 3) { // Image
            $url_end.= ($url_end == '') ? '' : '&img='.$arg2;
            $t = mysql_fetch_row(pwg_query('
             SELECT `name`, `file`
             FROM `'.IMAGES_TABLE.'`
             WHERE `id` = "'.$arg2.'"
            '));
            $dspl.=
             '<br>'.
             l10n('ec_dspl_ok_img2_pre').
             $arg2.
             l10n('ec_dspl_ok_img2_mid1').
             $t[0].
             l10n('ec_dspl_ok_img2_mid2').
             $t[1].
             l10n('ec_dspl_ok_img2_end')
            ;
          }
        break;
        case 2: // Additional Page
          $url_end = ($ec_entry['forced'] == 'true') ? '' : '&ap='.$arg2;
          $dspl = ($ec_ap_ok) ?
           l10n('ec_dspl_ok_ap_pre').
           $arg2.
           l10n('ec_dspl_ok_ap_mid').
           $ec_lists['add_pages'][$arg2_int].
           l10n('ec_dspl_ok_ap_end')
          :
           l10n('ec_dspl_ok_home')
          ;
        break;
      }
    break;
    
    case 'ec_nok' :
      if (empty($ec_entry['arg2'])) {
        $dspl = l10n('ec_dspl_nok_acc_denied');
      }
      else {
        $dspl = ($ec_ap_ok) ?
         l10n('ec_dspl_ok_ap_pre').
         $arg2.
         l10n('ec_dspl_ok_ap_mid').
         $ec_lists['add_pages'][$arg2_int].
         l10n('ec_dspl_ok_ap_end')
        :
         l10n('ec_dspl_nok_acc_denied')
        ;
      }
    break;
    
    case 'ec_nok_ap_pb' : // No need to check here if Additional Pages is
    case 'ec_ok_ap_pb' :  // active : we can arrive here only when it is.
      $page['errors'][] = 
       $ec_entry['code'].' : '.l10n('ec_add_page_miss');
      if (is_in($ec_entry['action'], 'ec_ok')) {
        $url_end = ($ec_entry['forced'] == 'true') ? '' : '&ap='.$arg2;
        $dspl = l10n('ec_dspl_ok_home');
      }
      else {
        $dspl = l10n('ec_dspl_nok_acc_denied');
      }
      $dspl.=
       $span_err_pre.
       l10n('ec_dspl_nok_ap_pre').
       $arg2.
       l10n('ec_dspl_nok_ap_end').
       $span_err_end
      ;
    break;
    
    case 'ec_ok_cat_pb' :
      $url_end = ($ec_entry['forced'] == 'true') ? '' : '&cat='.$arg1;
      $page['errors'][] = 
       $ec_entry['code'].' : '.l10n('ec_category_miss');
      $dspl =
       l10n('ec_dspl_nok_home').
       $span_err_pre.
       l10n('ec_dspl_nok_img1_pre').
       $arg1.
       l10n('ec_dspl_nok_img1_end').
       $span_err_end
      ;
    break;
    
    case 'ec_nok_action_pb' :
      $page['errors'][$ec_entry['code']] = 
       $ec_entry['code'].' : '.l10n('ec_action_pb');
      $username =
       $span_err_pre.
       l10n('ec_dspl_nok_actn').
       $span_err_end
      ;
      $dspl = l10n('ec_dspl_ok_home');
    break;
    
    case 'ec_nok_userid_pb' :
      $page['errors'][$ec_entry['code']] = 
       $ec_entry['code'].' : '.l10n('ec_username_pb');
      $username =
       $span_err_pre.
       l10n('ec_dspl_usr_pb').
       $span_err_end
      ;
      $dspl = l10n('ec_dspl_ok_home');
    break;
    
    case 'ec_nok_userid_miss' :
      $page['errors'][$ec_entry['code']] = 
       $ec_entry['code'].' : '.l10n('ec_username_miss');
      $username =
       $span_err_pre.
       l10n('ec_dspl_nok_usr_pre').
       $ec_entry['user_id'].
       l10n('ec_dspl_nok_usr_end').
       $span_err_end
      ;
      $dspl = l10n('ec_dspl_ok_home');
    break;
  }
  
  // construction of $code_URL
  $code_URL =
   ROOT_URL.
   'index.php?autolog='.
   $ec_entry['code'].
   $url_end
  ;
  
  $code_list[$i] = array(
   'id'       => $i,
   'Code'     => (isset($page['errors'][$ec_entry['code']])) ?
    $span_err_pre.$ec_entry['code'].$span_err_end : $ec_entry['code'],
   'Username' => $username,
   'Action'   => (is_in($ec_entry['action'], 'ec_nok_')) ?
    $span_err_pre.$ec_entry['action'].$span_err_end : $ec_entry['action'],
   'Arg1'     => $dspl,
   'Forced'   => $ec_entry['forced'],
   'code_URL' => $code_URL,
   'log_OK'   => $log_OK,
  );
}

$template->assign('ec_ap_ok',$ec_ap_ok);
$template->assign('code_list',$code_list);

?>