<?php
// +-----------------------------------------------------------------------+
// | Plugin Name : Event Cats                                              |
// | Plugin Version : 1.0                                                  |
// | File Version : 1.0                                                    |
// | Plugin Version author : LucMorizur                                    |
// | Plugin description : (plugin for Piwigo, http://piwigo.org )          |
// | This plugin allows an account to be automatically logged in ; and to  |
// | let users duplicate the account they are logged with, to get benefits |
// | of the groups of the previous account, immediately on their new acc.  |
// | Ce plugin permet d'identifier automatiquement un compte ; et permet à |
// | un utilisateur de dupliquer un compte, pour que le nouveau compte     |
// | bénéficie immédiatement de l'affectation aux groupes de l'ancien cpte |
// +-----------------------------------------------------------------------+

// +-----------------------------------------------------------------------+
// | Piwigo - a PHP based picture gallery                                  |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008-2009 Piwigo Team                  http://piwigo.org |
// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $template, $conf, $page,
 $ec_lists,   // array of following arrays :
              //   $ec_lists['ec_table'] :
              //     Event Cats table, in function of each entry id
              //   $ec_lists['ec_codes'] : // Used ?
              //     array of useful data, in function of entries codes
              //   $ec_lists['add_pages'] :
              //     array of Add. Pages names in function of their id
              //   $ec_lists['categories'] :
              //     array of category names in function of their id
              //   $ec_lists['user_ids'] :
              //     array of usernames in function of their id
 $ec_ap_ok;   // whether Additional Pages is installed and activated

/****************************************************************************/

build_ec_lists(); // in evntcats_funcs.php

$ec_lists['duplicable_codes'] = array();
$t = array();

foreach ($ec_lists['ec_table'] as $ec_entry) {
  if (
    is_in($ec_entry['action'], 'ec_ok') and
    $ec_entry['forced'] == 'false'
  ) {
    $t[$ec_entry['id']] = $ec_entry['code'];
    $ec_lists['duplicable_codes']['codes'][$ec_entry['code']]['id'] =
     $ec_entry['id'];
    $ec_lists['duplicable_codes']['codes'][$ec_entry['code']]['user_id'] =
     $ec_entry['user_id'];
  }
}
foreach ($t as $ec_id => $ec_code) {
  $ec_lists['duplicable_codes']['ids'][$ec_id] =
   $ec_lists['duplicable_codes']['codes'][$ec_code]['id'];
}

$ec_def_vals = array();

$ec_default_action = 'create_ask';
$ec_default_entry  = '-1';
$ec_def_auto_code_dg_nb = read_ec_conf('auto_code_dg_nb');

/*****************************************************************************
* $_GET and $_POST analysis.                                                 *
*****************************************************************************/

if (isset($_POST['ec_act1']) and isset($_POST['ec_entry_sel'])) {
  if (
    array_key_exists($_POST['ec_entry_sel'], $ec_lists['ec_table']) or
    $_POST['ec_entry_sel'] == '-1'
  ) {
    switch ($_POST['ec_act1']) {
      case 'duplicate_entry_submit': // submit failed
      case 'modify_entry_submit':    // submit failed
      case 'duplicate_entry_ask':
      case 'modify_entry_ask':
      case 'create_ask':
      case 'disable':
      case 'create':
        $ec_default_action = $_POST['ec_act1'];
        $ec_default_entry = $_POST['ec_entry_sel'];
      break;
      default:
        $page['errors'][] = 'Demande inconnue : $_POST[\'ec_act1\'] = '.$_POST['ec_act1'];
    }
  }
  else
   $page['errors'][] = 'Tentative d\'utilisation d\'une entrée inexistante ($_POST[\'ec_entry_sel\'] = '.$_POST['ec_entry_sel'].')';
}

/****************************************************************************/

$template->assign('ec_ap_ok',$ec_ap_ok);
$template->assign('ec_lists',$ec_lists);
$template->assign('ec_hidden_when_no_code',
  (count($ec_lists['duplicable_codes']) == 0) ? 'style = "display:none;"' : ''
);
$template->assign('ec_hidden_when_no_user',
  (count($ec_lists['user_ids']) == 0) ? 'style = "display:none;"' : ''
);
$template->assign('ec_is_creation', (
    $ec_default_action == 'duplicate_entry_submit' or
    $ec_default_action == 'duplicate_entry_ask' or
    $ec_default_action == 'create_ask' or
    $ec_default_action == 'create'
  )
);
$template->assign('ec_default_action',$ec_default_action);
$template->assign('ec_default_entry',$ec_default_entry);
$template->assign('ec_def_auto_code_dg_nb',$ec_def_auto_code_dg_nb);

?>